<?php

namespace iwaydev\components\helpers;

/**
 * Class AbstractErrorCode
 *
 * @package iwaydev\components\helpers
 */
abstract class AbstractErrorCode
{
    /**
     * Коды ошибок от 1000 - 1199. Приоритет обработки таких ошибок незначительный
     ****************************************************************************************/

    /**
     * Коды ошибок от 1200 - 1399. Приоритет обработки таких ошибок низкий
     ****************************************************************************************/

    /**
     * Коды ошибок от 1400 - 1599. Приоритет обработки таких ошибок средний
     ****************************************************************************************/

    /**
     * Коды ошибок от 1600 - 1799. Приоритет обработки таких ошибок высокий
     ****************************************************************************************/

    /**
     * Коды ошибок от 1800 - 1999. Приоритет обработки таких ошибок критический
     ****************************************************************************************/

    /**
     * Возвращает ID проекта в GitLab
     *
     * @return string
     */
    abstract public static function getProjectIdCode(): string;

    /**
     * Вернёт код ошибки проекта
     *
     * @param int $code Код ошибки
     *
     * @return string Код ошибки проекта
     */
    public static function getCodeProject(int $code)
    {
        return static::getProjectIdCode() . $code;
    }
}
