<?php

namespace iwaydev\components\helpers;

use Faker\Provider\Uuid;

/**
 * Class Base
 *
 * @package iwaydev\components\helpers
 */
class Base
{
    /**
     * Вернуть HTTP_X_UUID
     *
     * @return string HTTP_X_UUID
     */
    public static function getXUuid(): string
    {
        $xUuid = $_ENV['HTTP_X_UUID'] ?? null;
        if (empty($xUuid)) {
            $xUuid = Uuid::uuid();
        }

        return $xUuid;
    }

    /**
     * Получить реальный IP пользователя кто сделал запрос
     *
     * @return mixed
     */
    public static function getRealIp()
    {
        if (!empty($_SERVER['HTTP_X_REAL_IP'])) {
            $ip = $_SERVER['HTTP_X_REAL_IP'];
        } elseif (!empty($_SERVER['HTTP_CLIENT_IP'])) {
            $ip = $_SERVER['HTTP_CLIENT_IP'];
        } elseif (!empty($_SERVER['REMOTE_ADDR'])) {
            $ip = $_SERVER['REMOTE_ADDR'];
        } else {
            $ip = 'ip is not defined';
        }

        return $ip;
    }
}
