<?php

namespace iwaydev\components\helpers;

use Throwable;
use Yii;

/**
 * Хэлпер для работы с логами
 *
 * @package iwaydev\components\helpers
 */
class Log
{
    /**
     * Логируем исключение
     *
     * @param Throwable $t Экзепляр исключения
     * @param string $category Категоря лога
     * @param bool $stream Используется ли запись в стандартный поток вывода
     */
    public static function exception(Throwable $t, string $category, bool $stream = false): void
    {
        if ($stream) {
            Yii::error($t, $category);
        } else {
            Yii::error('', $category);
            Yii::error('Исключение!', $category);
            Yii::error('Сообщение: ' . $t->getMessage(), $category);
            Yii::error('Код: ' . $t->getCode(), $category);
            Yii::error('Файл: ' . $t->getFile() . '(' . $t->getLine() . ')', $category);
            Yii::error('Трейс: ' . PHP_EOL . $t->getTraceAsString(), $category);
            Yii::error('', $category);
        }
    }
}
